#include "MQBasePlugin.h"

#ifndef _UIWindowDefine
#define _UIWindowDefine

class MoveNormalWindow;

// CNX
class MoveNormal : public MQCommandPlugin
{
public:
	MoveNormal();
	virtual ~MoveNormal();

	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	virtual const char *GetPlugInName(void);
	virtual const char *EnumString(void);
	virtual BOOL Initialize();
	virtual void Exit();
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	virtual BOOL IsActivated(MQDocument doc);

	virtual void OnDraw(MQDocument doc, MQScene scene, int width, int height);
	virtual BOOL OnLeftButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	virtual BOOL OnLeftButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	virtual BOOL OnLeftButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	virtual BOOL OnUndo(MQDocument doc, int undo_state);
	virtual void OnUpdateObjectList(MQDocument doc);

	typedef bool (MoveNormal::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

	BOOL move(float val);

	void valChange(float val);
	void viewLine(bool flag);
	void checkNeighbor(bool flag);

private:
	MoveNormalWindow *m_Window;
	bool m_bActivate;
	float m_val;
	MQDocument m_doc;
	MQObject m_obj;
	MQObject m_draw;

	std::unordered_map<cmq::vindex_t, MQPoint> m_normal;
	bool m_normal_update;
	bool m_draw_update;
	bool m_viewLine;
	bool m_checkNeighbor;

	void createNormalViewObject();

	LONG m_MousePos_x;
	std::unordered_map<cmq::vindex_t, MQPoint> m_vertex_premoved;

};

#if MQPLUGIN_VERSION >= 0x0400

class MoveNormalWindow : public MQWindow
{
public:
	MoveNormalWindow(MoveNormal *plugin, MQWindowBase& parent);
	~MoveNormalWindow();

	MoveNormal *m_pPlugin;

	int mode;

private:
	MQDoubleSpinBox *spin;
	MQCheckBox *checkViewLine;
	MQCheckBox *checkCheckNeighbor;

	BOOL clickPlus(MQWidgetBase *sender, MQDocument doc);
	BOOL clickMinus(MQWidgetBase *sender, MQDocument doc);

	BOOL keyevent(MQWidgetBase *sender, MQDocument doc, MQWidgetKeyParam& param);
	BOOL valChange(MQWidgetBase *parent, MQDocument doc);
	BOOL viewLineChanged(MQWidgetBase *parent, MQDocument doc);
	BOOL checkNeighborChanged(MQWidgetBase *parent, MQDocument doc);

	friend class MoveNormal;
};
#else

#endif

#endif
